<template>
  <div class="q-px-sm q-pb-md">
    <div
      class="flex items-center"
      v-if="isLoadingConfig"
    >
      <q-spinner name="mat" size="32px"/>
      <span class="q-ml-sm">Loading collection config...</span>
    </div>
    <div v-if="config">
      <div class="q-headline">
        {{ config.name }}
      </div>
      <div
        v-if="config.description"
        class="q-subtitle"
        v-html="config.description"
      />
      <div v-if="config">
        <q-card
          v-for="(method, index) in methods"
          :key="index"
          class="q-mt-md bg-white"
        >
          <q-card-title>
            {{ method.name }}
            <div
              class="q-caption"
              v-if="method.description"
              v-html="method.description"
            />
          </q-card-title>
          <q-card-main>
            <report-table
              v-if="method.type === 'list'"
              :config="method.config"
              :id="id"
            />
            <action
              v-if="method.type === 'action'"
              :action="method.config"
            />
          </q-card-main>
        </q-card>
      </div>
    </div>
  </div>
</template>

<script>
  import QCard from 'quasar-framework/src/components/card/QCard';
  import endpointsMixin from '../../../../mixins/endpointsMixin';
  import ReportTable from './table/reportTable';
  import Action from '../action/action';

  export default {
    name: 'report',
    components: { QCard, Action, ReportTable },
    mixins: [endpointsMixin],
    props: {
      id: {
        type: [String, Number],
      },
    },
    created() {
      if (this.id) {
        this.loadConfig();
      }
    },
    computed: {
      methods() {
        return this.config.methods;
      },
    },
    data() {
      return {
        config: null,
        isLoadingConfig: false,
      };
    },
    watch: {
      id(id) {
        if (id) {
          this.config = null;
          this.$nextTick(() => {
            this.loadConfig();
          });
        }
      },
    },
    methods: {
      loadConfig() {
        this.isLoadingConfig = true;
        return new Promise((resolve) => {
          this.fetchCollectionByMenuId(+this.id)
            .then((config) => {
              this.config = config;
              this.isLoadingConfig = false;
              resolve();
            })
            .catch(() => {
              this.isLoadingConfig = false;
            });
        });
      },
    },
  };
</script>
